# test
# execute as @e[tag=aj.baradum.root] at @s run function ampsurv:boss/baradum/attacks/fireball/trigger

## ==================================================== HP DISPLAY BAR ======================================================
#display bar hp
execute if score worldScore wtc_4 matches 3.. store result bossbar minecraft:bosshp21 value run scoreboard players get baradum boss.storage.baradum

execute as @e[tag=baradum,type=piglin,tag=hurt,limit=1,sort=nearest] run function ampsurv:boss/baradum/system/hurtbox/operation

#display bar shield
execute if entity @s[tag=!phase2] if score worldScore wtc_4 matches 3.. store result bossbar minecraft:bosshp22 value run scoreboard players get baradum boss.baradum.shield

#display bar foul visage
execute if entity @s[tag=phase2] if score worldScore wtc_4 matches 3.. store result bossbar minecraft:bosshp22 value run scoreboard players get baradum boss.baradum.foul.visage

execute as @e[tag=baradum,type=piglin,tag=hurt,limit=1,sort=nearest] run function ampsurv:boss/baradum/system/foul-visage/loop

#display white if shield up
execute if entity @s[tag=!phase2] if score baradum boss.baradum.shield matches 2.. run bossbar set minecraft:bosshp22 color white
#reset display if shield is down
execute if entity @s[tag=!phase2] if score baradum boss.baradum.shield matches ..1 run bossbar set minecraft:bosshp22 players

#shield display
bossbar set minecraft:bosshp22 players @a[distance=..100]

#keep foul visage at max in phase 3
execute if entity @s[tag=phase3] run bossbar set minecraft:bosshp22 value 30


## ==================================================== MODEL MANAGER ======================================================
#hurt
execute if entity @e[tag=baradum_entity,type=piglin,tag=hurt] run bossbar set minecraft:bosshp21 color white
execute if entity @e[tag=baradum_entity,type=piglin,tag=hurt] if score baradum boss.baradum.shield matches ..1 run schedule function ampsurv:boss/baradum/system/hurtbox/bossbar 3t

#tp facing target
execute as @s[tag=!lock.rotation] at @s anchored eyes facing entity @e[tag=baradum_target,limit=1,sort=nearest] eyes positioned ^ ^ ^5 rotated as @s positioned ^ ^ ^20 facing entity @s eyes facing ^ ^ ^-1 positioned as @s run tp @s ~ ~ ~ ~ 0

## ================================================== SCORES ADD AND RESETS ======================================================
# score add and score resets
scoreboard players add baradum boss.battle_tick 1
execute if entity @s[tag=!dying] if score baradum boss.battle_tick matches 500.. run scoreboard players set baradum boss.battle_tick 1
execute if score baradum boss.battle_tick matches 250 run tag @e remove baradum_target
execute if score baradum boss.battle_tick matches 499 run tag @e remove baradum_target

#ability cd
scoreboard players remove baradum unenchantable_cd 1

# boss.storage2 animation cooldown
execute if score baradum boss.storage2 matches 1.. run scoreboard players remove baradum boss.storage2 1
# boss.storage1 attack cooldown
execute if score baradum boss.storage1 matches 1.. run scoreboard players remove baradum boss.storage1 1

#music
execute if score baradum boss.baradum.music matches 1.. run scoreboard players remove baradum boss.baradum.music 1
execute if score baradum boss.baradum.music matches 0 run playsound minecraft:boss.baradum.theme record @a[distance=..60] ~ ~ ~ 0.7 1 0.7
execute if score baradum boss.baradum.music matches 0 run scoreboard players set baradum boss.baradum.music 4600

execute as @e[tag=aj.baradum.root,tag=!dying,tag=!aj.baradum.animation.idle,type=item_display] at @s run function animated_java:baradum/animations/idle/play

## ========================================== ATTACKING SCRIPTS ======================================================
#targetting system
execute as @e[tag=baradum_entity,type=piglin] at @s if score worldScore wtc_10 matches 9.. run function ampsurv:boss/baradum/system/targetting
execute as @e[tag=baradum_entity,type=piglin] at @s run scoreboard players set @s generic.base.res 2

# attack randomizer
execute if score worldScore wtc_10 matches 9.. if score baradum ally.anim_tick matches ..5 run scoreboard players add baradum ally.anim_tick 1
execute if score worldScore wtc_10 matches 9.. if score baradum ally.anim_tick matches 5.. run scoreboard players set baradum ally.anim_tick 0

# effect loops
execute if entity @s[tag=flames_of_astaria_active] run function ampsurv:boss/baradum/attacks/flames-of-astaria/effect-loop
execute if entity @s[tag=phase2] run function ampsurv:boss/baradum/system/foul-visage/loop
execute if entity @s[tag=mantle_active] run function ampsurv:boss/baradum/attacks/mantle/effect-loop

# PRIORITIZED ATTACKS
execute if entity @s[tag=foa_explode_next] run function ampsurv:boss/baradum/attacks/foa-explode/wait
execute if entity @s[tag=teleport_next] run function ampsurv:boss/baradum/attacks/teleport/wait
execute if entity @s[tag=flames_next] run function ampsurv:boss/baradum/attacks/flames-of-astaria/wait
execute if entity @s[tag=mantle_next] run function ampsurv:boss/baradum/attacks/mantle/wait
execute if entity @s[tag=sealing_rings_next] run function ampsurv:boss/baradum/attacks/sealing-rings/wait
execute if entity @s[tag=cleanse_next] run function ampsurv:boss/baradum/attacks/cleansing-flame/wait
execute if entity @s[tag=cosmic_next] run function ampsurv:boss/baradum/attacks/cosmic-field/wait

#choose attack
execute as @e[tag=aj.baradum.root,type=item_display,tag=!dying,tag=!foa_explode_next,tag=!teleport_next,tag=!flames_next,tag=!mantle_next,tag=!sealing_rings_next,tag=!cleanse_next] at @s if score baradum boss.storage2 matches ..1 if score baradum boss.storage1 matches ..1 if score baradum boss.battle_tick matches 1.. run function ampsurv:boss/baradum/attacks/phases/manager

#anim loops
execute if entity @s[tag=aj.baradum.animation.foa_explode] run function ampsurv:boss/baradum/attacks/foa-explode/loop
execute if entity @s[tag=aj.baradum.animation.flames_of_astaria] run function ampsurv:boss/baradum/attacks/flames-of-astaria/loop
execute if entity @s[tag=aj.baradum.animation.fireball] run function ampsurv:boss/baradum/attacks/fireball/loop
execute if entity @s[tag=aj.baradum.animation.fireball_storm] run function ampsurv:boss/baradum/attacks/fireball-storm/loop
execute if entity @s[tag=aj.baradum.animation.flamethrower] run function ampsurv:boss/baradum/attacks/flamethrower/loop
execute if entity @s[tag=aj.baradum.animation.flame_sweep] run function ampsurv:boss/baradum/attacks/flame-sweep/loop
execute if entity @s[tag=aj.baradum.animation.encasing_flames] run function ampsurv:boss/baradum/attacks/encasing-flames/loop
execute if entity @s[tag=aj.baradum.animation.cleansing_flame] run function ampsurv:boss/baradum/attacks/cleansing-flame/loop
execute if entity @s[tag=aj.baradum.animation.sealing_rings] run function ampsurv:boss/baradum/attacks/sealing-rings/loop
execute if entity @s[tag=aj.baradum.animation.cosmic_field] run function ampsurv:boss/baradum/attacks/cosmic-field/loop
execute if entity @s[tag=aj.baradum.animation.bloodflame_splitfire] run function ampsurv:boss/baradum/attacks/bloodflame-splitfire/loop
execute if entity @s[tag=aj.baradum.animation.mantle] run function ampsurv:boss/baradum/attacks/mantle/loop
execute if entity @s[tag=aj.baradum.animation.raise_undead] run function ampsurv:boss/baradum/attacks/raise-undead/loop
execute if entity @s[tag=aj.baradum.animation.break] run function ampsurv:boss/baradum/system/poise/loop

## ========================================== PHASES DETECT ======================================================
function ampsurv:boss/baradum/attacks/projectile_manager

# phase changes
# if after poise break, change phase -> 2
#done in poise break func

#change phase to 3 if foul visage full ->

#change phase to 3.1 if less than 20% HP
execute as @e[tag=aj.baradum.root,type=item_display] if score baradum boss.storage.baradum matches ..100 run function ampsurv:boss/baradum/system/phases/3.1

## ========================================== DEFEAT AND RETREAT ======================================================
# check
execute as @e[tag=aj.baradum.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s if score baradum boss.storage.baradum matches ..1 run function ampsurv:boss/baradum/system/defeat-trig
#loop
execute as @e[tag=aj.baradum.root,type=item_display,tag=dying,tag=scened,tag=!retreating] at @s run function ampsurv:boss/baradum/system/defeat

#retreat
execute unless entity @a[tag=!dead,distance=..100] run tag @s add retreating
#loop
execute as @e[tag=aj.baradum.root,type=item_display,tag=retreating,tag=!dying,tag=scened] run function ampsurv:boss/baradum/system/retreat
