# Irine boss AI
# Entity : Piglin NoAI (tags: boss, irine_entity)
# movements : everytime after an attack, Irine chooses 1 of 8 random locations and then move toward that location. 
# Attack1 : Shoots a homing icebolt to irene_target, dealing AOE damage upon impact
# Attack2 : Shoots a laser of cold towards irene_target. Deals damage on a line.
# Attack3 : crystal Frost - Deals heavy damage in an AOE after a delay on the irine_target area. Slows allies hit.
# Super1 : Frost Rythm - goes to the middle and starts chanting a rythm. Whenever any Ally within the area stops moving for a total of 2s
#           They are afflicted by huge slow, blind, and weakness, also receiving dps.
# Super2 : Blizzard Dance - Creates 4 Frigus Mana crystals on the arena. Then starts a blizzard that slows down all allies.
#           during this, icicles erupt from the ground after a visual delay on random areas. The icicles deal massive damage and slows allies hit.
#           Irene will keep on dancing while any one of the Frigus Mana crystals are still active.

execute store result score irine boss.storage.irine run data get entity @e[tag=irine_entity,limit=1,sort=nearest] Health

# score add and score resets
scoreboard players add irine boss.battle_tick 1
execute if entity @e[tag=irine_entity,type=piglin,distance=..10] if score irine boss.battle_tick matches 500.. run scoreboard players set irine boss.battle_tick 1
execute if score irine boss.battle_tick matches 250 run tag @e remove irine_target
execute if score irine boss.battle_tick matches 499 run tag @e remove irine_target

#music
execute if score irine boss.irine.music matches 1.. run scoreboard players remove irine boss.irine.music 1
execute if score irine boss.irine.music matches 0 run playsound minecraft:boss.worldboss.theme record @a[distance=..50] ~ ~ ~ 0.7 1 0.7
execute if score irine boss.irine.music matches 0 run scoreboard players set irine boss.irine.music 3400

#hurt
execute if entity @e[tag=irine_entity,type=piglin,tag=hurt] run bossbar set minecraft:bosshp14 color white
execute if entity @e[tag=irine_entity,type=piglin,tag=hurt] run schedule function ampsurv:boss/irine/system/bossbar 3t

#tp
execute as @e[tag=aj.irine.root,type=item_display] run tp @e[tag=irine_entity,type=piglin,limit=1,sort=nearest] @s

#targetting system
execute as @e[tag=irine_entity,type=piglin] at @s if score worldScore wtc_10 matches 9.. run function ampsurv:boss/irine/system/targetting
execute as @e[tag=irine_entity,type=piglin] at @s run scoreboard players set @s generic.base.res 2

# attack randomizer
execute if score worldScore wtc_10 matches 9.. if score irine ally.anim_tick matches ..5 run scoreboard players add irine ally.anim_tick 1
execute if score worldScore wtc_10 matches 9.. if score irine ally.anim_tick matches 5.. run scoreboard players set irine ally.anim_tick 0

# boss.storage2 animation cooldown
execute if score irine boss.storage2 matches 1.. run scoreboard players remove irine boss.storage2 1
# boss.storage1 attack cooldown
execute if score irine boss.storage1 matches 1.. run scoreboard players remove irine boss.storage1 1

execute if score irine boss.battle_tick matches ..1 if score irine boss.storage2 matches ..1 as @e[tag=aj.irine.root,tag=!attack,tag=!dying] at @s run function animated_java:irine/animations/idle/next_frame
execute if score irine boss.battle_tick matches 1.. if score irine boss.storage2 matches ..1 as @e[tag=aj.irine.root,tag=!attack,tag=!dying] at @s run function animated_java:irine/animations/idle_battle/next_frame

#tp facing target
execute as @s at @s anchored eyes facing entity @e[tag=irine_target,limit=1,sort=nearest] eyes positioned ^ ^ ^5 rotated as @s positioned ^ ^ ^20 facing entity @s eyes facing ^ ^ ^-1 positioned as @s run tp @s ~ ~ ~ ~ 0

#choose attack
execute if entity @s[tag=blizzard_next] run function ampsurv:boss/irine/attacks/blizzard/wait
execute as @e[tag=aj.irine.root,type=item_display,tag=!attack,tag=!dying,tag=!blizzard_next] at @s if score irine boss.storage2 matches ..1 if score irine boss.storage1 matches ..1 if score irine boss.battle_tick matches 1.. run function ampsurv:boss/irine/attacks/phases/manager

#loops
execute if entity @e[tag=irine_r1_time,type=area_effect_cloud] run function ampsurv:boss/irine/attacks/hitbox/r1
execute if entity @e[tag=irine_r2_time,type=area_effect_cloud] run function ampsurv:boss/irine/attacks/hitbox/r2
execute if entity @e[tag=irine_cf_time,type=area_effect_cloud] run function ampsurv:boss/irine/attacks/hitbox/cf
execute if entity @e[tag=irine_is_time,type=area_effect_cloud] run function ampsurv:boss/irine/attacks/hitbox/is
execute if entity @e[tag=irine_fr_time,type=area_effect_cloud] run function ampsurv:boss/irine/attacks/frost-rythm/loop

execute if entity @s[tag=moving,tag=!dying,tag=!blizzard-dance] unless entity @e[tag=irine_fr_time] run function ampsurv:boss/irine/attacks/move/loop
execute if entity @s[tag=blizzard-dance] run function ampsurv:boss/irine/attacks/blizzard/loop

execute if entity @e[tag=irine_standing_place_spreader,type=area_effect_cloud] run function ampsurv:boss/irine/system/standing_places/spread
function ampsurv:boss/irine/attacks/projectile_manager

#percent detections
#75%
execute as @e[tag=aj.irine.root,type=item_display,tag=!75_percent] if score irine boss.storage.irine matches ..525 run function ampsurv:boss/irine/system/percent_detect/75
#50%
execute as @e[tag=aj.irine.root,type=item_display,tag=!50_percent] if score irine boss.storage.irine matches ..350 run function ampsurv:boss/irine/system/percent_detect/50

#death
# add tag
#execute as @e[tag=aj.irine.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s unless entity @e[tag=irine_entity,distance=..10,type=piglin] run tellraw @a[distance=..50] ["",{"text":"\n"},{"text":"\u1360","color":"dark_red"},{"text":" Irene","bold":true,"color":"red"},{"text":" has been defeated!","color":"dark_red"},{"text":"\n "}]
execute as @e[tag=aj.irine.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s unless entity @e[tag=irine_entity,distance=..10,type=piglin] run scoreboard players set irine boss.battle_tick 611
execute as @e[tag=aj.irine.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s unless entity @e[tag=irine_entity,distance=..10,type=piglin] run tellraw @a[distance=..50] ["",{"text":"< ","color":"white"},{"text":"Irine","bold":true,"color":"red"},{"text":" > ","color":"white"},{"text":"Witless Cross bearer.. Why covet New Moon?","color":"light_purple"}]
execute as @e[tag=aj.irine.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s unless entity @e[tag=irine_entity,distance=..10,type=piglin] run execute at @a[distance=..50] run summon experience_orb ~ ~ ~ {Value:4500,Motion:[0d,0.3d,0d]}
execute as @e[tag=aj.irine.root,type=item_display,tag=!dying,tag=scened,tag=!retreating] at @s unless entity @e[tag=irine_entity,distance=..10,type=piglin] run tag @s add dying
# loop
execute as @e[tag=aj.irine.root,type=item_display,tag=dying,tag=scened,tag=!retreating] at @s run function ampsurv:boss/irine/system/defeat

#retreat
execute unless entity @a[tag=!dead,distance=..60] run tag @s add retreating
#loop
execute as @e[tag=aj.irine.root,type=item_display,tag=retreating,tag=!dying,tag=scened] run function ampsurv:boss/irine/system/retreat