import os

# Define the directory where folders are located
root_directory = "C:\\Users\\neall\\AppData\\Roaming\\.minecraft\\saves\\Northlandar Dev World\\datapacks\\Mageria Datapack Main\\data\\ampsurv\\functions\\relic\\item"

# Content to be inserted at the top of the tell.mcfunction file
additional_content = '''tellraw @s ["",{{"text":"\\u1360","color":"red"}},{{"text":"     ","strikethrough":true}},{{"text":"\\u1360","color":"red"}},{{"text":" === Amulet Information ===","bold":false,"color":"dark_aqua"}},{{"text":" \\u1360","color":"red"}},{{"text":"     ","bold":true,"strikethrough":true}},{{"text":"\\u1360","color":"red"}}]

function ampsurv:relic/item/{folder_name}/tell

'''

# Iterate over each item in the root directory
for folder_name in os.listdir(root_directory):
    folder_path = os.path.join(root_directory, folder_name)
    
    # Check if the item is a directory
    if os.path.isdir(folder_path):
        # Define the file path
        file_path = os.path.join(folder_path, "recipe.mcfunction")
        
        # Read the existing content of the file
        if os.path.exists(file_path):
            with open(file_path, 'r') as file:
                existing_content = file.read()
        else:
            existing_content = ""

        # Create the new content by combining the additional content and the existing content
        new_content = additional_content.format(folder_name=folder_name) + existing_content
        
        # Write the new content back to the file
        with open(file_path, 'w') as file:
            file.write(new_content)

print("tell.mcfunction files updated in each folder.")