import os
import json

def to_snake_case(name):
    return name.lower().replace('-', '_')

folder_path = 'C:\\Users\\nadisaputr001\\Documents\\GitHub\\Mageria-Datapack-Main\\data\\ampsurv\\functions\\relic\\item'

# Function to create a .json file for each folder
def create_json_files_for_folders(path):
    for item in os.listdir(path):
        item_path = os.path.join(path, item)
        if os.path.isdir(item_path):
            # Create a dictionary to store folder information
            folder_info = {
                "__comment": "Made by JekNJok",
                "criteria": {
                    "obtain": {
                        "trigger": "minecraft:inventory_changed",
                        "conditions": {
                            "items": [
                                {
                                    "nbt": f"{{{to_snake_case(item)}:1}}",
                                    "item": "minecraft:gold_nugget"
                                }
                            ]
                        }
                    }
                },
                "rewards": {
                    "experience": 5,
                    "function": "ampsurv:relic/item/discover-new-amulet-message"
                }
            }

            # Define the json file name
            json_file_name = os.path.join(path, f"{item}.json")

            # Write the dictionary to a json file
            with open(json_file_name, 'w') as json_file:
                json.dump(folder_info, json_file, indent=4)
            print(f"Created {json_file_name}")

# Call the function
create_json_files_for_folders(folder_path)