import json
import os

# Define the mapping of amulet names to CustomModelData values
custom_model_data_map = {
    "golden_sun": 1,
    "diamond_moon": 2,
    "lionhearted": 3,
    "fleeting_shadows": 4,
    "ring_of_regen": 5,
    "deepgrove_talisman": 6,
    "runic_twig": 7,
    "ruby_ring": 8,
    "amethyst_ring": 9,
    "sapphire_ring": 10,
    "emerald_ring": 11,
    "topaz_ring": 12,
    "old_arus": 13,
    "knight_pendant": 14,
    "big_sapphire": 15,
    "big_emerald": 16,
    "big_amethyst": 17,
    "big_ruby": 18,
    "big_topaz": 19,
    "bloodfang_necklace": 20,
    "silver_bracelet": 21,
    "ruby_bracelet": 22,
    "amethyst_bracelet": 23,
    "sapphire_bracelet": 24,
    "emerald_bracelet": 25,
    "topaz_bracelet": 26,
    "silver_necklace": 27,
    "ruby_necklace": 28,
    "amethyst_necklace": 29,
    "sapphire_necklace": 30,
    "emerald_necklace": 31,
    "topaz_necklace": 32,
    "diamond_necklace": 33,
    "rainbow_brooch": 34,
    "golden_chalice": 35,
    "angelicas_ring": 36,
    "barethas_ring": 37,
    "bloodstone": 38,
    "band_of_gyes": 39,
    "pagan_lumina": 40,
    "forest_magi_emblem": 41,
    "phoenix_plume": 42,
    "forest_flute": 43,
    "spirit_flute": 44,
    "diamond_apple": 45,
    "armlet-of-the-wind": 46,
    "chivalric-seal": 47,
    "solomon-seal": 48,
    "band-of-duskwillow": 49,
    "skull-ring": 50,
    "spirit-ring": 51,
    "nimueh-offering": 52,
    "orb-of-poison": 53,
    "orb-of-life": 54,
    "orb-of-ruin": 55,
    "fateful-relic": 56,
    "spite-stone": 57,
    "proof-of-continuance": 58,
    "red-eyed-serpentine": 59,
    "morbid-armlet": 60,
    "vonriz-daenerys": 61,
    "charm-of-concord": 62,
    "bracer-of-vitality": 63,
    "ring-of-accordance": 64,
    "yilsurs-guard": 65,
    "butterfly-charm": 66,
    "ethos-booster": 67,
    "lucid-orb": 68,
    "veynria-key": 69,
    "mirinda-key": 70,
    "crimson-lament": 71,
    "dancer-in-prisms": 72,
    "goblin-talisman": 73,
    "shield-pendant": 74,
    "bow-charm": 75,
    "beast-tooth-talisman": 76,
    "jagged_rock": 77,
    "warrior-talisman": 78,
    "prismatic-ring": 80,
    "spade-charm": 81,
    "lunar-monk-ring": 82,
    "feather-bracelet": 84,
    "forest-mask": 85,
    "gold-masquerade": 86,
    "tarot-cards": 87,
    "vahaans-grief": 88,
    "great-horn": 89,
    "wheel-of-misfortune": 90,
    "gilded-cards": 91,
    "soulstone-charm": 92,
    "crimsonheart": 93,
    "precious-box": 94,
    "violet-mezmeraza": 96,
    "orbuculum": 97,
    "flaming-skull": 98,
    "cos-mosiers-will": 99,
    "torc-of-greater-warding": 100,
    "pandoras-box": 101,
    "brisingamen": 102,
    "skull-of-razvan": 103,
    "mekhanisma": 105,
    "spirit-orb": 106,
    "ring-of-discord": 107,
    "moon-lotus-ring": 108,
    "hoarfrost-billet": 109,
    "moonstone-charm": 110,
    "grotesque-stone": 111,
    "slabs-of-myrnar": 112,
    "arcane-chains": 113,
    "adamant-ring": 114,
    "guardian-ring": 115,
    "bezoar": 116,
    "birdcage-locket": 117,
    "primatic-band": 118,
    "conqueror-crown": 119,
    "sanguine-diadem": 120,
    "regal-bracer": 121,
    "band-of-the-magi": 122,
    "manaward-bracer": 123,
    "witching-choker": 124,
    "epitome-orb": 125,
    "mystic-ring": 126,
    "mystic-pendant": 127,
    "mystic-masque": 128,
    "mystic-band": 129,
    "aristocrat-masquerade": 130,
    "prismatic-band": 131,
    "carnelian-stone": 132,
    "meddenroda-amulet": 133,
    "adoring-arch": 134,
    "precious-locket": 135,
    "goldsun-birthright": 136,
    "ring-of-valor": 137,
    "shards-of-winter": 138,
    "orb-of-golden-flames": 139,
    "gisella-carapace": 140,
    "armlet-of-nital": 141,
    "duskwillow-branch": 142,
    "band-of-thorns": 143,
    "woodhorn-armlet": 144,
    "flower-band": 145,
    "silverhorn-armlet": 146,
    "flower-bauble": 147,
    "necklace-of-toughness": 148,
    "ars-magna": 149,
    "valkyrie-bracer": 150,
    "ornate-bell": 151,
    "barb-of-madness": 152,
    "old-stone-tablet": 153,
    "ars-ceruleum-actum": 154,
    "emblem-of-the-dark-baron": 155,
    "fractal-sins": 156,
    "arzum-sundial": 157,
    "glass-bird": 158,
    "valkyrie-bracers": 159,
    "coffers-of-razvan": 160,
    "eye-of-laniriden": 161,
    "spiritfox-mask": 162,
    "adjudicator-ring": 163,
    "valkyrie-sigil": 164,
    "brilliant-locket": 165,
    "lordsworn-bracers": 166,
    "orchid-ring": 167,
    "gilded-gauntlet": 168,
    "antikythera-mechanism": 169,
    "forsaken-relic": 170,
    "whispering_souls": 171,
    "verdant_winds": 172,
    "scroll-of-the-damned": 173,
    "necrotic-hand": 174,
    "spirit-flower": 175,
    "wyndsought-crest": 176,
    "vulcan-brazenplate": 177,
    "ring-of-starry-nights": 178,
    "visage-of-knowledge": 179,
    "chalice-of-crimson-nights": 180,
    "pendant-of-azure-nights": 181,
    "crown-of-twelve-stars": 182,
    "urn-of-remains": 183,
    "remains-of-naphtali": 184,
    "coffers-of-naphtali": 185,
    "core-of-chaos": 186,
    "orb-of-erasmus": 187,
    "shackles-of-djinnia": 188,
    "shade": 189,
    "arcis-stella-corona": 190
}


# Define the base template structure based on adamant-ring.json
advancement_template = {
    "__comment": "Made by JekNJok",
    "display": {
        "title": {
            "text": "",
            "color": "dark_aqua",
            "bold": True
        },
        "description": {
            "text": "",
            "color": "gray"
        },
        "icon": {
            "item": "minecraft:gold_nugget",
            "nbt": ""
        },
        "frame": "task",
        "show_toast": True,
        "announce_to_chat": false,
        "hidden": True
    },
    "criteria": {
        "obtain": {
            "trigger": "minecraft:inventory_changed",
            "conditions": {
                "items": [
                    {
                        "item": "minecraft:gold_nugget",
                        "nbt": ""
                    }
                ]
            }
        }
    },
    "rewards": {
        "experience": 5,
        "function": "ampsurv:relic/item/discover-new-amulet-message"
    },
    "parent": "amu-adv:root"
}

# Define the output directory
output_directory = "data/amu-adv/1"

# Ensure the directory exists
os.makedirs(output_directory, exist_ok=True)

# Generate updated advancement files
for amulet_name, model_data in custom_model_data_map.items():
    new_advancement = advancement_template.copy()

    # Update names dynamically
    new_advancement["display"]["title"]["text"] = amulet_name.replace("-", " ").title()
    new_advancement["display"]["description"]["text"] = f"type /trigger amulet.{amulet_name} to view its info."

    # Set the correct CustomModelData
    new_advancement["display"]["icon"]["nbt"] = f'{{CustomModelData:{model_data}}}'
    new_advancement["criteria"]["obtain"]["conditions"]["items"][0]["nbt"] = f'{{{amulet_name.replace("-","_")}:1}}'

    # Define the file path
    file_path = os.path.join(output_directory, f"{amulet_name}.json")

    # Write the file
    with open(file_path, "w", encoding="utf-8") as file:
        json.dump(new_advancement, file, indent=4)

print("Advancement files updated successfully.")